'--------------------------
' DateTime
'--------------------------  

Type FDateTime Extends Control	
	public: 
	Declare Property Color(ByVal value As UInteger) OVERRIDE
	Declare Property Color As UInteger OVERRIDE
	Declare Property TextColor(ByVal value As UInteger) OVERRIDE
	Declare Property TextColor As UInteger OVERRIDE
	
	Declare Property DateTime(value As String) 
   Declare Property DateTime As String 
   
   Declare Property Border(ByVal value As Integer) 
   Declare Property Border As Integer
  
   Declare Sub Create(ByVal hParent As HWND,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer, ByVal typ As Const Integer = 0 )
   Declare Constructor
   Declare Destructor  
   
   ' Events	
	onChange As Sub( dateTime as String)	
	onLButtondown As Sub(ByVal x As Short, ByVal y As Short)
	onRButtondown As Sub(ByVal x As Short, ByVal y As Short)
	 
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Private:
   DECLARE static FUNCTION DateTimeSubFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT  
   As Integer b_ParentColor
	As Integer b_format
   As Integer b_CloseUp 
   As UInteger b_Color
	As UInteger b_TextColor
	As Integer  b_Border
   As UInteger b_oldProc = 0   
End Type
Constructor FDateTime
	
	If InitDateTime = 0 Then
		Dim as INITCOMMONCONTROLSEX icex	
	   icex.dwSize = sizeof(icex)
	   icex.dwICC  = ICC_DATE_CLASSES
	   InitCommonControlsEx(@icex)  ' muss nur einmal aufgerufen werden
	   InitDateTime = 1
	End If
	
	this.b_Color = &HFFFFFF
	this.b_TextColor = &H0
	this.b_CloseUp = 0
	this.b_format = 0
	this.b_Border = 0
  	this.Handle   = 0
  	this.ExStyle  = 0	
	this.Style 	  = WS_CHILD Or WS_VISIBLE 
End Constructor

Destructor FDateTime
	
   this.Handle  = 0
   
End Destructor

Property FDateTime.Color(ByVal value As UInteger) 
	If this.Handle Then
		This.b_Color = value
		SendMessage(this.Handle, DTM_SETMCCOLOR,  MCSC_MONTHBK, value)
	End If
End Property
Property FDateTime.Color As UInteger 
		Return This.b_Color
End Property
Property FDateTime.TextColor(ByVal value As UInteger) 
	If this.Handle Then
		This.b_textColor = value
		SendMessage(this.Handle, DTM_SETMCCOLOR, MCSC_TEXT, value )
	End If
End Property
Property FDateTime.TextColor As UInteger 
		Return This.b_textColor
End Property	
Property FDateTime.DateTime(value As String)  ' mm/dd/yyyy
	Dim As SYSTEMTIME st
	Dim sDate As String 
	sDate = Trim(value)
	If this.Handle Then
		SendMessage(this.Handle,DTM_GETSYSTEMTIME,0,Cast(LPARAM, @st))
		Select Case this.b_format
			Case 4,5
			st.wHour = Val(Left(sDate,2))
			st.wMinute=Val(mid(sDate,4,2))
			st.wSecond=Val(Right(sDate,2))
			Case Else	
			st.wYear = Val(Right(sDate,4))
			st.wDay  = Val(mid(sDate,4,2))
			st.wMonth= Val(Left(sDate,2))
		End Select	
		SendMessage(this.Handle,DTM_SETSYSTEMTIME,GDT_VALID,Cast(LPARAM, @st))
	EndIf
End Property
Property FDateTime.DateTime As String 
	Dim As SYSTEMTIME st
	Dim As String * 64 sDate 
   sDate = String(64,Chr(0))
	If this.Handle Then
		SendMessage(this.Handle,DTM_GETSYSTEMTIME,0,Cast(LPARAM, @st))
		If st.wYear <> 0 Then 
			Select Case this.b_format
			Case 4,5
				sDate = Str(st.wHour )+"/"+Str(st.wMinute )+"/"+Str(st.wSecond) 						' HH/MM/SS
			Case Else
				sDate = Str(st.wMonth)+"/"+Str(st.wDay)+"/"+Str(st.wYear)+"/"+Str(st.wDayOfWeek) ' mm/dd/yyyy/DayOfWeek
			End Select
		Else
			sDate =""
		EndIf
	EndIf
	Return sDate
End Property
   
Property FDateTime.Border(Byval value As Integer) 
	Dim As UInteger NewStyle
	NewStyle=GetWindowLong(this.Handle,GWL_STYLE)
	select case value
		Case 0
			this.b_Border = 0
			this.Style 	  =  NewStyle And(Not WS_BORDER)
			this.ExStyle  =  WS_EX_CLIENTEDGE 
		Case 1
			this.b_Border = 1
			this.Style 	 =  NewStyle OR WS_BORDER
			this.ExStyle =  0
	End Select
	
	If this.Handle Then		
		SetWindowLong(this.Handle,GWL_STYLE,this.Style)
		SetWindowLong(this.Handle,GWL_EXSTYLE,this.ExStyle)
		repaint
	EndIf

End Property
Property FDateTime.Border As Integer 
	Return this.b_Border
End Property
   

Function FDateTime.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Function = 0 
  
  	
   Select case uMsg   	
    	Case WM_ENABLE 
   		this.Enabled = wParam
   		Exit Function
   		
   	Case WM_SIZE
   		If this.Handle Then
    			MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
   		End If
    		Exit Function 
    		
    	Case WM_PARENTNOTIFY
   		If LoWord(wParam)= WM_LBUTTONDOWN	Then
   			If this.onLButtondown Then
  					onLButtondown(LOWORD(lParam),HIWORD(lParam))
   			End If  			
   		EndIf
   		If LoWord(wParam)= WM_RBUTTONDOWN	Then
   			If this.onRButtondown Then
  					onRButtondown(LOWORD(lParam),HIWORD(lParam))
   			End If  	
   		EndIf
   		Exit Function  
    		
   	Case WM_NOTIFY
    	  	Dim AS NMDATETIMECHANGE Ptr pNm = Cast(NMDATETIMECHANGE Ptr ,lParam)
    	  	Dim As String * 64 sDate 
    	  	Dim As SYSTEMTIME st
    	  	sDate = String(64,Chr(0))
			
			If pNm->nmhdr.code = DTN_DROPDOWN  Then 
				b_CloseUp = 1	
			EndIf
			
			If pNm->nmhdr.code = DTN_CLOSEUP  Then
				SendMessage(this.Handle,DTM_GETSYSTEMTIME,0,CInt(@st))
				If st.wYear = 0 Then Exit Function
				Select Case this.b_format
					Case 4,5
						sDate = Str(st.wHour )+"/"+Str(st.wMinute )+"/"+Str(st.wSecond) 						' HH/MM/SS
					Case Else
						sDate = Str(st.wMonth)+"/"+Str(st.wDay)+"/"+Str(st.wYear)+"/"+Str(st.wDayOfWeek) ' mm/dd/yyyy/DayOfWeek
				End Select
    	  		
				If this.onChange Then
					this.onChange(sDate)
				End If	
				b_CloseUp = 0	
			EndIf
			
    	  	If (pNm->nmhdr.code = DTN_DATETIMECHANGE) And (b_CloseUp = 0) Then    	  		
    	  		SendMessage(this.Handle,DTM_GETSYSTEMTIME,0,CInt(@st))
    	  		If st.wYear = 0 Then Exit Function
    	  		
    	  		Select Case this.b_format
					Case 4,5
						sDate = Str(st.wHour )+"/"+Str(st.wMinute )+"/"+Str(st.wSecond) 						' HH/MM/SS
					Case Else
						sDate = Str(st.wMonth)+"/"+Str(st.wDay)+"/"+Str(st.wYear)+"/"+Str(st.wDayOfWeek) ' mm/dd/yyyy/DayOfWeek
				End Select
    	  		
				If this.onChange Then
					this.onChange(sDate)
				End If	
    	  	End If
   		Exit Function 
   	Case WM_DESTROY
   		If this.Handle Then
				SetWindowLong(this.Handle, GWL_WNDPROC, this.b_oldProc)
				this.b_oldProc =0
			End If
   		Exit Function 
   End Select
  
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function
'
FUNCTION FDateTime.DateTimeSubFunc(hWnd AS HWND ,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	Function = 0
		
	Dim as FDateTime ptr DTime = cast(FDateTime Ptr,GetWindowLong(hWnd,GWL_USERDATA)) 
	
	If DTime = 0 Then
		function = DefWindowProc( hWnd, uMsg, wParam, lParam) 
		Exit Function
	EndIf
	
	Select case uMsg
		
		Case WM_ERASEBKGND 
			Dim As RECT rc 
			Dim As HDC dc = Cast(HDC, wParam)
			Dim As HBRUSH hBr = CreateSolidBrush(DTime->Color)
			GetClientRect(hWnd,@rc)
			FillRect(dc,@rc,hBr)
			DeleteObject(hBr)
			Function = 1
			Exit Function
			
	End Select
	
	function = CallWindowProc( Cast(Any Ptr,DTime->b_oldProc), hWnd, uMsg, wParam, lParam) 
End Function
Sub FDateTime.Create(ByVal hParent As HWND,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer, ByVal typ As Const Integer = 0 )

   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
         
   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE Or WS_CHILD  , x, y, w , h , _                    
                          hParent , NULL, hInst , NULL )
                                                   
   SetWindowLong(this.CtHandle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
                                                                    
   If this.CtHandle  Then  		
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
   	this.Parent  = hParent  	
   Else
   	MessageBox(0,"Fehler - Create FDateTime Container","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
      
   '-------------- DatetimePick -------------------------  
   szClass =  DATETIMEPICK_CLASS  
   Select Case typ
   	Case 0
			this.b_format = 0
			this.Style 	 =  WS_CHILD Or WS_VISIBLE  Or DTS_SHORTDATEFORMAT 
		Case 1
			this.b_format = 1
			this.Style 	 =  WS_CHILD Or WS_VISIBLE  Or DTS_SHORTDATEFORMAT Or DTS_SHOWNONE
		Case 2
			this.b_format = 2
			this.Style 	 =  WS_CHILD Or WS_VISIBLE  Or DTS_LONGDATEFORMAT 
		Case 3
			this.b_format = 3
			this.Style 	 =  WS_CHILD Or WS_VISIBLE  Or DTS_LONGDATEFORMAT Or DTS_SHOWNONE 
		Case 4
			this.b_format = 4
			this.Style  =  WS_CHILD Or WS_VISIBLE  Or DTS_TIMEFORMAT Or DTS_UPDOWN	
		Case 5
			this.b_format = 5
			this.Style  =  WS_CHILD Or WS_VISIBLE  Or DTS_TIMEFORMAT Or DTS_UPDOWN	Or DTS_SHOWNONE	  		
   	Case Else
   		this.b_format = 0
			this.Style 	 =  WS_CHILD Or WS_VISIBLE  Or DTS_SHORTDATEFORMAT 
   End Select
                    
   this.Handle = CreateWindowEx( this.ExStyle  ,@szClass ,"", this.Style  ,  0, 0, w, h , this.CtHandle , NULL, hInst , NULL )                                            
   If this.Handle = 0 Then
   	MessageBox(0,"Fehler - Create FDateTime","Fehler",MB_ICONERROR)
   	Exit Sub
   EndIf  
   SetWindowLong(this.Handle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz  
   this.b_oldProc = SetWindowLong( this.Handle, GWL_WNDPROC, CInt(@FDateTime.DateTimeSubFunc))
   
End Sub