'--------------------------------------------------------------------
' 		Edit-mehrzeilig
'-------------------------------------------------------------------- 
Type FMemo Extends Control
	
	public:		   
	Declare Constructor
   Declare Destructor
	 
   Declare Property Border(ByVal value As Integer)
   Declare Property Border As Integer
   Declare Property Text As String 
	Declare Property Text(sText As String )
	Declare Property TextLen(ByVal value As Integer)
   Declare Property TextLen As Integer
   Declare Property LineCount (ByVal value As Integer)
   Declare Property LineCount  As Integer
   Declare Property CurLine (ByVal value As Integer)
   Declare Property CurLine  As Integer
   Declare Property LMargin(ByVal value As Integer)   
   Declare Property LMargin As Integer
   Declare Property RMargin(ByVal value As Integer)   
   Declare Property RMargin As Integer
   Declare Property ReadOnly As Integer
   Declare Property ReadOnly(ByVal value As Integer)
   Declare Property AutoHScroll(ByVal value As Integer)
   Declare Property AutoHScroll  As Integer
   Declare Property AutoVScroll(ByVal value As Integer)
   Declare Property AutoVScroll  As Integer
   Declare Property HScroll(ByVal value As Integer)
   Declare Property HScroll  As Integer
   Declare Property VScroll(ByVal value As Integer)
   Declare Property VScroll  As Integer
   
   Declare Function GetLineText(ByVal LineNr As Integer) As String
   Declare Sub ReplaceLineText(ByVal LineNr As Integer, sTxt As String) 
 	Declare Sub AddLine( sTxt As String)
   Declare Sub SaveFile(filename As String)   
	Declare Sub LoadFile(filename As String) 
   Declare Sub Cut()
   Declare Sub Copy()
   Declare Sub Paste()
   Declare Sub Clear 
   Declare Sub ClearAll
   
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer)
   DECLARE Function CtrlMsgFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
  
   ' Events	
	onChange  As SUB()	
	onUpdate As Sub()
	onLButtondown As Sub(ByVal x As Short, ByVal y As Short)
	onLButtonUp As Sub(ByVal x As Short, ByVal y As Short)
	onRButtondown As Sub(ByVal x As Short, ByVal y As Short)
	OnKeyDown As Sub(nKey AS Integer,lKeyStatus As Integer)
	OnKeyUp As Sub(nKey AS Integer,lKeyStatus As Integer)
	OnSetFocus As Sub(ByVal hWnd As HWND)
	
	Private:  
	DECLARE static FUNCTION MemoSubClassFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	As String	b_Text		= ""
   As HBRUSH	b_Brush		= 0
	As UInteger b_border		= 1
	As Integer  b_ReadOnly  = 0
	As Integer  b_AutoVScr  = 1
	As Integer  b_AutoHScr  = 0
	As Integer  b_VScr  		= 1
	As Integer  b_HScr  		= 1
	As UInteger b_oldProc	= 0
End Type
Constructor FMemo
  	this.Handle  = 0
  	this.Color   = &HFFFFFF
  	this.ExStyle = WS_EX_CLIENTEDGE 
	this.Style 	 = WS_CHILD Or WS_VISIBLE Or ES_MULTILINE Or ES_WANTRETURN Or ES_AUTOVSCROLL Or WS_VSCROLL Or WS_HSCROLL

end Constructor
Destructor FMemo	
	
	this.Handle = 0
	
end Destructor
Property FMemo.HScroll(ByVal value As Integer)
	Dim styles As UInteger
	If this.Handle Then
		this.b_HScr = IIf(value,TRUE,FALSE)
		styles = GetWindowLong(this.Handle,GWL_STYLE)		
		If value Then
			styles = styles Or WS_HSCROLL 
		Else
			styles = styles And(not WS_HSCROLL)
		End If
		SetWindowLong(this.Handle,GWL_STYLE,styles)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf
End Property
Property FMemo.HScroll  As Integer
	Return this.b_HScr
End Property
Property FMemo.VScroll(ByVal value As Integer)
	Dim styles As UInteger
	If this.Handle Then
		this.b_VScr = IIf(value,TRUE,FALSE)
		styles = GetWindowLong(this.Handle,GWL_STYLE)		
		If value Then
			styles = styles Or WS_VSCROLL 
		Else
			styles = styles And(not WS_VSCROLL)
		End If
		SetWindowLong(this.Handle,GWL_STYLE,styles)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf
End Property
Property FMemo.VScroll  As Integer
	Return this.b_VScr
End Property
Property FMemo.AutoHScroll(ByVal value As Integer)
	Dim styles As UInteger
	If this.Handle Then
		this.b_AutoHScr = IIf(value,TRUE,FALSE)
		styles = GetWindowLong(this.Handle,GWL_STYLE)		
		If value Then
			styles = styles Or ES_AUTOHSCROLL 
		Else
			styles = styles And(not ES_AUTOHSCROLL)
		End If
		SetWindowLong(this.Handle,GWL_STYLE,styles)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf
End Property
Property FMemo.AutoHScroll  As Integer
	Return this.b_AutoHScr
End Property
Property FMemo.AutoVScroll(ByVal value As Integer)
	Dim styles As UInteger
	If this.Handle Then
		this.b_AutoVScr = IIf(value,TRUE,FALSE)
		styles = GetWindowLong(this.Handle,GWL_STYLE)		
		If value Then
			styles = styles Or ES_AUTOVSCROLL 
		Else
			styles = styles And(not ES_AUTOVSCROLL)
		End If
		SetWindowLong(this.Handle,GWL_STYLE,styles)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf
End Property
Property FMemo.AutoVScroll  As Integer
	Return this.b_AutoVScr
End Property
Property FMemo.ReadOnly As Integer
	If this.Handle Then
		Return this.b_ReadOnly
   End If
End Property
Property FMemo.ReadOnly(ByVal value As Integer)
	If this.Handle Then
		If value = 0 Then
			this.b_ReadOnly = 0
		 	SendMessage(this.Handle, EM_SETREADONLY,FALSE,0) 
		Else	
			this.b_ReadOnly = 1
			SendMessage(this.Handle, EM_SETREADONLY,TRUE,0)  
		EndIf	
   End If
End Property

Property FMemo.RMargin(ByVal value As Integer)
	Dim As RECT rc
	If this.Handle Then
		SendMessage(this.Handle,EM_GETRECT , 0 , Cast(WPARAM,@rc)) 
		rc.right = rc.right - value - 1
		SendMessage(this.Handle,EM_SETRECT  , 0 , Cast(WPARAM,@rc)) 
	End If
End Property
Property FMemo.RMargin As Integer
	Dim As RECT rc
	If this.Handle Then
		SendMessage(this.Handle,EM_GETRECT  , 0 ,Cast(WPARAM,@rc)) 
		Return this.ClientWidth-rc.right
	End If
End Property

Property FMemo.LMargin(ByVal value As Integer)
	Dim As RECT rc
	If this.Handle Then
		SendMessage(this.Handle,EM_GETRECT , 0 , Cast(WPARAM,@rc)) 
		rc.left = rc.left + value
		SendMessage(this.Handle,EM_SETRECT  , 0 , Cast(WPARAM,@rc)) 
	End If
End Property
Property FMemo.LMargin As Integer
	Dim As RECT rc
	If this.Handle Then
		SendMessage(this.Handle,EM_GETRECT  , 0 ,Cast(WPARAM,@rc)) 
		Return rc.left
	End If
End Property
Property FMemo.CurLine (ByVal value As Integer) ' Line basis 1

	Dim As Integer iMin,iMax,nLine
	If this.Handle Then	
		nLine = SendMessage(this.Handle,EM_GETLINECOUNT,0,0)
		If (value <= nLine) And (value > 0)  Then
			nLine = value - 1
			iMax = SendMessage(this.Handle,EM_LINEINDEX ,nLine,0) 
			iMin = iMax
			SendMessage(this.Handle, EM_SETSEL ,iMin,iMax) 
		 	SetFocus(this.Handle)
		End If
	End If
	
End Property
Property FMemo.CurLine  As Integer ' Line basis 1
	Dim As Integer iMax,iMin
	If this.Handle Then
		SendMessage(this.Handle, EM_GETSEL ,Cast(WPARAM, @iMin) ,Cast(LPARAM, @iMax) )
		iMin = SendMessage(this.Handle, EM_LINEFROMCHAR , iMax ,0 ) + 1
		Return iMin
	End If
End Property
Property FMemo.LineCount (ByVal value As Integer)
 '
End Property
Property FMemo.LineCount  As Integer ' basis 1
	If this.Handle Then	
		Return SendMessage(this.Handle,EM_GETLINECOUNT,0,0)
	End if	
End Property

Property FMemo.Border As Integer
 	Return this.b_border 
End Property

Property FMemo.Border(ByVal Value As Integer)
	Dim As UInteger styles
	If this.Handle Then	
		styles = GetWindowLong(this.Handle,GWL_STYLE)
		Select Case value
			Case 0				' Ohne
				this.Style = styles And (Not WS_BORDER)
				this.ExStyle  = 0
			Case 1				' Sunken
				this.Style = styles And (Not WS_BORDER)
				this.ExStyle  = WS_EX_CLIENTEDGE
			Case 2				' Border
				this.Style = styles Or WS_BORDER
				this.ExStyle  = 0
		End Select
		this.b_border = value
		SetWindowLong(this.Handle,GWL_STYLE,this.Style)
		SetWindowLong(this.Handle,GWL_EXSTYLE,this.ExStyle)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf	
End Property

Property FMemo.TextLen As Integer
	If this.Handle Then
		Return GetWindowTextLength(this.Handle) 
	EndIf
End Property
Property FMemo.TextLen(ByVal value As Integer)
	'
End Property
Property FMemo.Text As String 	
	If this.Handle Then	
		Dim  As Integer maxCount,i
		maxCount = GetWindowTextLength(this.Handle) 
		this.b_Text = String(maxCount+2,Chr(0))  
		i = GetWindowText(this.Handle , StrPtr(this.b_Text) , maxCount+1 )	
		Return this.b_Text
	EndIf
End Property
Property FMemo.Text(sText As String )
	If this.Handle Then
		this.b_Text = sText
		SetWindowText(this.Handle ,sText)		
	EndIf
End Property
Sub FMemo.Cut()
	If this.Handle Then
		SendMessage(this.Handle,WM_CUT,0,0)
	EndIf
End Sub
Sub FMemo.Copy()
	If this.Handle Then
		SendMessage(this.Handle,WM_COPY,0,0)
	EndIf
End Sub
Sub FMemo.Paste()
	If this.Handle Then
		SendMessage(this.Handle,WM_PASTE,0,0)
	EndIf
End Sub
Sub FMemo.Clear
	If this.Handle Then
		SendMessage(this.Handle, WM_CLEAR, 0, 0)
	EndIf
End Sub
Sub FMemo.ClearAll
	If this.Handle Then
		SendMessage(this.Handle, EM_SETSEL, 0, -1)
		SendMessage(this.Handle, WM_CLEAR, 0, 0)
	EndIf
End Sub

Sub FMemo.ReplaceLineText(ByVal LineNr As Integer, sTxt As String) ' Line Base 1
	Dim As Integer nLine,iMin,iMax
	Dim As HANDLE hGlobal
	Dim As Byte Ptr pGlobal
	Dim As String sStr
	
	If this.Handle Then	
		nLine = SendMessage(this.Handle,EM_GETLINECOUNT,0,0)
		If (LineNr <= nLine) And (LineNr >= 0) Then
			If LineNr < 1 Then 
				nLine = 1
			Else
				nLine = LineNr-1
			EndIf		
			iMin = SendMessage(this.Handle,EM_LINEINDEX ,nLine,0)
			iMax = SendMessage(this.Handle,EM_LINELENGTH ,iMin,0)+iMin
			SendMessage(this.Handle, EM_SETSEL ,iMin,iMax) 
			SendMessage(this.Handle, WM_CLEAR, 0, 0)
			sStr = sTxt + Chr(0)
			
	   	hGlobal = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT OR GMEM_SHARE,Len(sStr))
	   	If hGlobal THEN
	     		pGlobal = GlobalLock(hGlobal)
	    		CopyMemory (pGlobal, @sStr[0], Len(sStr)-1)
	     	 	GlobalUnlock(hGlobal) 
	     	 	
		   	OpenClipboard(this.Handle)                  
		   	EmptyClipboard
		   	SetClipboardData(CF_TEXT ,hGlobal)                  
		   	CloseClipboard

	   	End If                 
   		SendMessage(this.Handle,WM_PASTE,0,0)
		 	SetFocus(this.Handle)
		End If
	End If
	
End Sub
Function FMemo.GetLineText(ByVal LineNr As Integer) As String ' Base 1
	Dim As String s
	If this.Handle Then
		s = String(256,Chr(0)) ' String muss initialisiert sein
		s[0] = 255 ' 1. Word (2Byte) Anzahl der Byte die kopiert werde drfen
		s[1] = 0 
		If LineNr < 1 Then 
			LineNr = 1
		EndIf
		LineNr -=1
		If SendMessage(this.Handle, EM_GETLINE ,LineNr,CInt(@s[0])) <> 0 Then 
			Return s
		Else
			s = String(1,Chr(0))
		End If
	End If
		Return s
End Function

Sub FMemo.AddLine( sTxt As String)
	Dim As Integer nLine,iMin,iMax
	Dim As HANDLE hGlobal
	Dim As Byte Ptr pGlobal
	Dim As String sStr
	
	If this.Handle Then
		iMax = GetWindowTextLength(this.Handle) 
		SendMessage(this.Handle, EM_SETSEL ,iMax,iMax) 
		If iMax = 0 Then
			sStr = sTxt + Chr(0)
		Else
			sStr = Chr(13,10)+sTxt + Chr(0)
		EndIf
		
		hGlobal = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT OR GMEM_SHARE,Len(sStr))
	   	If hGlobal THEN
	     		pGlobal = GlobalLock(hGlobal)
	    		CopyMemory (pGlobal, @sStr[0], Len(sStr)-1)
	     	 	GlobalUnlock(hGlobal) 
	     	 	
		   	OpenClipboard(this.Handle)                  
		   	EmptyClipboard
		   	SetClipboardData(CF_TEXT ,hGlobal)                  
		   	CloseClipboard

	   	End If                 
   		SendMessage(this.Handle,WM_PASTE,0,0)
		 	SetFocus(this.Handle)
	End If
End Sub
Sub  FMemo.SaveFile(filename As String)  
	
	Dim fNr AS Integer = Freefile
	Open filename For Binary As #fNr
	Put #fNr, , this.Text
	Close #fNr
	
End Sub
Sub  FMemo.LoadFile(filename As String) 
	
	Dim As String sByte 
	Dim AS Integer fNr = FreeFile
	Dim AS Integer nByte 
	
	If isFileExist(filename) = 0 Then
		MessageBox(0," Fehler - Datei nicht gefunden","Fehler", MB_ICONERROR)
		Exit sub
	EndIf
	nByte = isFilesize(filename)
	If nByte = 0 Then Exit Sub
	sByte = String(nByte,Chr(0))
	Open filename For Binary As #fNr
	Get #fNr, , sByte	
	Close #fNr
	this.Text = sByte
	
End Sub
Function FMemo.CtrlMsgFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
     	   
   Function = 0
     	   
   SELECT CASE uMsg
        CASE WM_ENABLE
         this.Enabled = wParam
         EXIT FUNCTION

        CASE WM_SETFONT,WM_SETTEXT
         IF this.Handle THEN
             FUNCTION = SendMessage(this.Handle,uMsg,wParam,lParam)
         END IF
         EXIT FUNCTION

        CASE WM_SIZE
         IF this.Handle THEN
             MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
         END IF
         EXIT FUNCTION   
                
   	Case WM_PARENTNOTIFY
   		If LoWord(wParam)= WM_LBUTTONDOWN	Then
   			If this.onLButtondown Then
  					onLButtondown(LOWORD(lParam),HIWORD(lParam))
   			End If  			
   		EndIf
   		If LoWord(wParam)= WM_RBUTTONDOWN	Then
   			If this.onRButtondown Then
  					onRButtondown(LOWORD(lParam),HIWORD(lParam))
   			End If  	
   		EndIf
   		Exit Function  
   		
   	Case WM_CTLCOLOREDIT
			SetBkColor(Cast(HDC, wParam),this.Color)
   		SetTextColor(Cast(HDC, wParam),this.TextColor ) 
   		If this.b_Brush Then
   			DeleteObject(this.b_Brush)
   		EndIf
   		this.b_Brush = CreateSolidBrush(this.Color)
   		Function = Cast(LRESULT,this.b_Brush ) 	 		
	      Exit Function  
	      		
   	Case  WM_COMMAND    		
   		If HiWord(wParam) = EN_CHANGE Then 
   			If this.onChange Then onChange() 	
   			Function = 0
   			Exit Function
   		End If
   		If HiWord(wParam) = EN_UPDATE  Then 
   			If this.onUpdate Then onUpdate() 	
   			Function = 0
   			Exit Function
   		End If
   		
   	Case WM_DESTROY	
			If this.b_Brush Then
				DeleteObject(this.b_Brush)
				this.b_Brush = 0
			End If
			SetWindowLong(this.Handle, GWL_WNDPROC, this.b_oldProc)
			this.b_oldProc = 0
			Function = 0
   		Exit Function
   End Select 
   
   function = DefWindowProc(  hWnd, uMsg, wParam, lParam)  
end Function
Function FMemo.MemoSubClassFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	
	Function = 0
	Dim As Integer lKeyDat = 0
	Dim As UInteger dwRet
	
	Dim as FMemo ptr Edit = cast(FMemo Ptr,GetWindowLong(hWnd,GWL_USERDATA)) ' Zeiger auf diese Klasse
	
	If Edit = 0 Then
		function = DefWindowProc(  hWnd, uMsg, wParam, lParam) 
		Exit Function
	EndIf
	
	Select case uMsg
		Case WM_SETFOCUS 
			If Edit->OnSetFocus Then Edit->OnSetFocus(hWnd)	
								   					
		Case WM_KEYDOWN			
			If GetKeyState(VK_SHIFT) < -126 Then
				lKeyDat = VK_SHIFT	'&H10
			ElseIf GetKeyState(VK_CONTROL) < -126 Then	
				lKeyDat = VK_CONTROL	'&H11
			ElseIf GetKeyState(VK_MENU) < -126 Then		
				lKeyDat = VK_MENU		'&H12
			End If		
   		If Edit->OnKeyDown Then Edit->OnKeyDown(wParam,lKeyDat)
   		
		Case WM_KEYUP			
			If GetKeyState(VK_SHIFT) < -126 Then
				lKeyDat = VK_SHIFT	'&H10
			ElseIf GetKeyState(VK_CONTROL) < -126 Then	
				lKeyDat = VK_CONTROL	'&H11
			ElseIf GetKeyState(VK_MENU) < -126 Then		
				lKeyDat = VK_MENU		'&H12
			End If		
   		If Edit->OnKeyUp Then Edit->OnKeyUp(wParam,lKeyDat)
		Case WM_LBUTTONUP
			If Edit->onLButtonUp Then Edit->onLButtonUp(LOWORD(lParam),HIWORD(lParam))

	End Select
	
	function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
End Function
Sub FMemo.Create(ByVal hParent As HWND,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	      
   
   DIM AS ZString * 32 szClass
   DIM AS HINSTANCE hInst

   szClass     = "FB_CONTROL"
   hInst        = GetModuleHandle(0)

   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , x, y, w , h , _
                          hParent , NULL, hInst , NULL )

   SetWindowLong(this.CtHandle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz

   IF this.CtHandle  THEN
        this.Left    = x
        this.Top     = y
        this.Width   = w
        this.Height  = h
        this.Parent  = hParent
   ELSE
        MessageBox(0,"Fehler - Create Memo","Fehler",MB_ICONERROR)
        EXIT SUB
   END IF

   this.Handle = CreateWindowEx( this.ExStyle ,"EDIT" , "" , this.Style  , 0, 0, w, h , this.CtHandle , NULL, hInst , NULL )
   IF this.Handle = 0 THEN
        MessageBox(0,"Fehler - Create Memo","Fehler",MB_ICONERROR)
        Exit Sub
   EndIf  
	
	SetWindowLong(this.Handle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz 
	this.b_oldProc = SetWindowLong( this.Handle, GWL_WNDPROC, CInt(@FMemo.MemoSubClassFunc))
	' max. Text auf 64 KB
	SendMessage(this.Handle,EM_SETLIMITTEXT ,0,0) 
End Sub
