'--------------------------  
' MonthCal
'--------------------------  

Type FMonthCal Extends Control	
	public: 
	Declare Property Color(ByVal value As UInteger) OVERRIDE
	Declare Property Color As UInteger OVERRIDE
	Declare Property TextColor(ByVal value As UInteger) OVERRIDE
	Declare Property TextColor As UInteger OVERRIDE
	Declare Property TitleColor(ByVal value As UInteger) 
	Declare Property TitleColor As UInteger 
	Declare Property TitleTextColor(ByVal value As UInteger) 
	Declare Property TitleTextColor As UInteger 
	
	Declare Property CurSel( value As String)
	Declare Property CurSel As String 
 	
 	Declare Property CurDay( value As String)
	Declare Property CurDay As String 
 	
 	Declare Property NoToDay(ByVal value As Integer) ' true = ohne Heute
	Declare Property NoToDay As Integer
	
 	Declare Property Border(ByVal value As Integer)
	Declare Property Border As Integer
	
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer)
   Declare Constructor
   Declare Destructor 
    
   ' Events	
	onSelect As Sub( CalPick as String)
	onSelChange As Sub(CalPick as String)
	onLButtondown As Sub(ByVal x As Short, ByVal y As Short)
	onRButtondown As Sub(ByVal x As Short, ByVal y As Short)
	' Func
	Declare Sub CalSize	 
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Private: 
   DECLARE static FUNCTION MonthCalSubFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	As Integer  b_ToDay = False
   As Integer  b_Border = 0
	As UInteger b_CalColor 
	As UInteger b_txtColor 
	As UInteger b_TitleColor 
	As UInteger b_TitleTextColor
	As UInteger b_oldProc	= 0   
End Type
Constructor FMonthCal
	
	If InitDateTime = 0 Then
		Dim as INITCOMMONCONTROLSEX icex	
	   icex.dwSize = sizeof(icex)
	   icex.dwICC  = ICC_DATE_CLASSES 
	   InitCommonControlsEx(@icex)  	 ' muss nur einmal aufgerufen werden
	   InitDateTime = 1					 ' nicht bei jeder Instanz
	End If
	this.b_ToDay = FALSE
	this.b_Border = 0
	this.b_TitleColor = &HFF0000
	this.b_TitleTextColor = &H0
	this.b_CalColor = &HFFFFFF
	this.b_txtColor = &H0
  	this.Handle   = 0
  	this.ExStyle  = 0 
	this.Style 	  = WS_CHILD or WS_VISIBLE  OR WS_TABSTOP  
End Constructor

Destructor FMonthCal
   this.Handle  = 0
End Destructor

Property FMonthCal.Color(ByVal value As UInteger) 
	If this.Handle Then
		This.b_CalColor = value
		SendMessage(this.Handle, MCM_SETCOLOR, MCSC_MONTHBK, value)
	End If
End Property
Property FMonthCal.Color As UInteger 
		Return This.b_CalColor
End Property
Property FMonthCal.TextColor(ByVal value As UInteger) 
	If this.Handle Then
		This.b_txtColor = value
		SendMessage(this.Handle, MCM_SETCOLOR, MCSC_TEXT, value)
	End If
End Property
Property FMonthCal.TextColor As UInteger 
		Return This.b_txtColor
End Property	

Property FMonthCal.TitleColor(ByVal value As UInteger) 
	If this.Handle Then
		This.b_TitleColor = value
		SendMessage(this.Handle, MCM_SETCOLOR, MCSC_TITLEBK ,value )
	End If
End Property
Property FMonthCal.TitleColor As UInteger 
		Return This.b_TitleColor
End Property
Property FMonthCal.TitleTextColor(ByVal value As UInteger) 
	If this.Handle Then
		This.b_TitleTextColor = value
		SendMessage(this.Handle,MCM_SETCOLOR, MCSC_TITLETEXT ,value )
	End If
End Property
Property FMonthCal.TitleTextColor As UInteger 
	Return This.b_TitleTextColor
End Property
	
Property FMonthCal.CurSel( value As String)  'mm/dd/yyyy
	Dim st As SYSTEMTIME
	Dim sDate As String 
	sDate = Trim(value)
	If this.Handle Then
		MonthCal_GetCurSel(this.Handle,@st)
		st.wYear = Val(Right(sDate,4))
		st.wDay  = Val(mid(sDate,4,2))
		st.wMonth= Val(Left(sDate,2))
		MonthCal_SetCurSel(this.Handle,@st)		
	End if
End Property
Property FMonthCal.CurSel As String
	Dim st As SYSTEMTIME
	Dim sDate As String * 64
	sDate = String(64,Chr(0))
	If this.Handle Then
		MonthCal_GetCurSel(this.Handle,@st)
		sDate = Str(st.wMonth)+"/"+Str(st.wDay)+"/"+Str(st.wYear)+"/"+Str(st.wDayOfWeek)	  'mm/dd/yyyy/dayofweek
	End If
	Return sDate
End Property

Property FMonthCal.CurDay( value As String)  'mm/dd/yyyy
	Dim st As SYSTEMTIME
	Dim sDate As String 
	sDate = Trim(value)
	If this.Handle Then
		MonthCal_GetToday(this.Handle,@st)
		st.wYear = Val(Right(sDate,4))
		st.wDay  = Val(mid(sDate,4,2))
		st.wMonth= Val(Left(sDate,2))
		MonthCal_SetToday(this.Handle,@st)		
	End if
End Property
Property FMonthCal.CurDay As String
	Dim st As SYSTEMTIME
	Dim sDate As String * 64
	sDate = String(64,Chr(0))
	If this.Handle Then
		MonthCal_GetToday(this.Handle,@st)
		sDate = Str(st.wMonth)+"/"+Str(st.wDay)+"/"+Str(st.wYear)+"/"+Str(st.wDayOfWeek) 'mm/dd/yyyy/dayofweek
	End If
	Return sDate
End Property

Property FMonthCal.NoToDay(ByVal value As Integer) ' true = ja, false = nein
	Dim As UInteger tmpStyle
	If this.Handle Then
		this.b_ToDay = IIf(value,TRUE,FALSE)
		tmpStyle = GetWindowLong(this.Handle,GWL_STYLE)
		If this.b_ToDay Then
			this.Style = tmpStyle Or  MCS_NOTODAY
		Else
			this.Style = tmpStyle And (NOT  MCS_NOTODAY)
		EndIf
		SetWindowLong(this.Handle,GWL_STYLE,this.Style)
		CalSize
	EndIf
End Property
Property FMonthCal.NoToDay As Integer
	Return this.b_ToDay
End Property
	
Property FMonthCal.Border(ByVal value As Integer)
   Dim As UInteger tmpStyle
   If this.Handle Then
	   tmpStyle = GetWindowLong(this.Handle,GWL_STYLE)
		Select Case value
			Case 0
				this.b_Border = 0
				this.Style = tmpStyle And (Not WS_BORDER)
				this.ExStyle  = 0 
			Case 1
				this.b_Border = 1
				this.Style = tmpStyle OR WS_BORDER
				this.ExStyle  = 0 
			Case 2
				this.b_Border = 2
				this.Style = tmpStyle And (Not WS_BORDER)
				this.ExStyle = WS_EX_CLIENTEDGE	 
		End Select
	
		SetWindowLong(this.Handle,GWL_STYLE,this.Style)
		SetWindowLong(this.Handle,GWL_EXSTYLE,this.ExStyle)
		CalSize
	EndIf
End Property
Property FMonthCal.Border As Integer
	Return this.b_Border
End Property
	
Function FMonthCal.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Function = 0 
  	
   Select case uMsg 
   	
    	Case WM_ENABLE 
   		this.Enabled = wParam
   		Exit Function
   			
   	Case WM_SIZE
   		If this.Handle Then
    			MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
   		End If
    		Exit Function 
    	
    	Case WM_PARENTNOTIFY
   		If LoWord(wParam)= WM_LBUTTONDOWN	Then
   			If this.onLButtondown Then
  					onLButtondown(LOWORD(lParam),HIWORD(lParam))
   			End If  			
   		EndIf
   		If LoWord(wParam)= WM_RBUTTONDOWN	Then
   			If this.onRButtondown Then
  					onRButtondown(LOWORD(lParam),HIWORD(lParam))
   			End If  	
   		EndIf
   		Function = 0
   		Exit Function  
   			
   	Case WM_NOTIFY
    	  	Dim AS NMSELCHANGE Ptr pNMSel = Cast(NMSELCHANGE Ptr ,lParam) 
    	  	Dim As String * 64 sDate 	
    	  	sDate = String(64,Chr(0))
    	  	Dim st As SYSTEMTIME

    	  	If pNMSel->nmhdr.code = MCN_SELECT THEN 
				MonthCal_GetCurSel(this.Handle,@st)
				sDate = Str(st.wMonth)+"/"+Str(st.wDay)+"/"+Str(st.wYear)+"/"+Str(st.wDayOfWeek)	  'mm/dd/yyyy/dayofweek
	    	  	If this.onSelect Then
					this.onSelect(sDate)
	    	  	End If
    	  	EndIf
    	  	
    	  	If (pNMSel->nmhdr.code = MCN_SELCHANGE) THEN 
    	  		MonthCal_GetCurSel(this.Handle,@st)
				sDate = Str(st.wMonth)+"/"+Str(st.wDay)+"/"+Str(st.wYear)+"/"+Str(st.wDayOfWeek)  
	    	  	If this.onSelChange Then	
					this.onSelChange(sDate)
	    	  	End If	
    	  	End If
    	  	Exit Function 
    	  	
   	Case WM_DESTROY
   		If this.Handle Then
				SetWindowLong(this.Handle, GWL_WNDPROC, this.b_oldProc)
				this.b_oldProc = 0
			End If
   		Exit Function 
   End Select
  
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function
'
Function FMonthCal.MonthCalSubFunc(hWnd AS HWND ,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	Function = 0
		
	Dim as FMonthCal ptr MonthCal = cast(FMonthCal Ptr,GetWindowLong(hWnd,GWL_USERDATA)) 
	
	If MonthCal = 0 Then
		function = DefWindowProc( hWnd, uMsg, wParam, lParam) 
		Exit Function
	EndIf
	
	Select case uMsg
		
		Case WM_SETFONT
			function = CallWindowProc( Cast(Any Ptr,MonthCal->b_oldProc), hWnd, uMsg, wParam, lParam)
			MonthCal->CalSize
			Exit Function
			
	End Select
	
	function = CallWindowProc( Cast(Any Ptr,MonthCal->b_oldProc), hWnd, uMsg, wParam, lParam) 
End Function

Sub FMonthCal.CalSize
	Dim As RECT rc
	Dim As Integer metrh = 0
	Dim As Integer metrv = 0
	
	If this.b_Border = 1 Then
		metrh = GetSystemMetrics(SM_CXBORDER) * 2							
		metrv = GetSystemMetrics(SM_CYBORDER) * 2							
	ElseIf this.b_Border = 2 Then												
		metrh = GetSystemMetrics(SM_CXEDGE) * 2							
		metrv = GetSystemMetrics(SM_CYEDGE) * 2
	End If
	   
	SendMessage(this.Handle , MCM_GETMINREQRECT, 0, CInt( @rc)) 	
	
	this.Height = rc.bottom  + metrv 							
	this.Width  =  rc.right + metrh 
	
	SetWindowPos(this.CtHandle, NULL, this.left, this.Top , this.Width, this.Height , SWP_NOZORDER) 
End Sub

Sub FMonthCal.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer )

   Dim As ZString * 32 szClass	
   Dim As HINSTANCE hInst
 	
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
         
   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE Or WS_CHILD  , x, y, x , y , _                    
                          hParent , NULL, hInst , NULL )
                                                   
   SetWindowLong(this.CtHandle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
                                                                    
   If this.CtHandle  Then  		
   	this.Left	 = x
		this.Top		 = y
    	this.Parent  = hParent  	
   Else
   	MessageBox(0,"Fehler - Create FMonthCal Container","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
   '-------------- Pager -------------------------  
   szClass =  MONTHCAL_CLASS                  
   this.Handle = CreateWindowEx( this.ExStyle  ,@szClass ,"", this.Style  ,  0, 0, 0, 0 , this.CtHandle , NULL, hInst , NULL )                                            
   If this.Handle = 0 Then
   	MessageBox(0,"Fehler - Create FMonthCal","Fehler",MB_ICONERROR)
   	Exit Sub
   EndIf  
   SetWindowLong(this.Handle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz  
   this.b_oldProc = SetWindowLong( this.Handle, GWL_WNDPROC, CInt(@FMonthCal.MonthCalSubFunc))  
   SendMessage( this.Handle, MCM_SETMAXSELCOUNT, 31, 0)
   CalSize
    	
End Sub