
' Nur die Control.bi verwenden, die auch bentigt werden
' FForm und Menu ist automatisch dabei und muss nicht extra benannt werden


#define F_Panel
#define F_Image
#define F_ComDlg ' einzige Ausnahme beim Sybolnamen , enthlt FOpenFile,FSaveFile,FPrintDlg

'-----------------------------------------------------------------------

#Include "winFBgui2.bi"

Dim Shared As FForm  form1 
Dim Shared As FPanel panel1 
Dim Shared As FImage img1
Dim Shared As FOpenFile fopen
Dim As FMenuItem mnOpen, mnExit

'------------- Event-Sub ------------------------------------
Sub form1_Vscroll(ByVal nPos As Short)
	panel1.Top  = (nPos*-1)
End Sub

Sub form1_Hscroll(ByVal nPos As Short)
	panel1.Left  = (nPos*-1)
End Sub

Sub panel1_Paint(ByVal hDC As HDC)
	img1.ImgCopy(hDC,0,0)
End Sub

Sub menu_Open
	Dim sFile As String
	
	sFile = ""
	fopen.Filter = "Bitmap|*.bmp|Jpg|*.jpg|PNG|*.png"	
	fopen.FilterIndex = 2    ' Stellt JPG ein'
	If fopen.Execute(form1.Handle) Then	
		sFile = fopen.FileName
		
		img1.LoadImg(sFile) ' Bild Laden
		
		If img1.ImgWidth > Form1.ClientWidth Then
			form1.SetHscroll(0,(img1.ImgWidth - Form1.ClientWidth))
		Else
			form1.SetHscroll(0,0) ' Scrollbar ausblenden wenn nicht gebraucht
		EndIf

		If img1.ImgHeight >Form1.ClientHeight Then
			form1.SetVscroll(0,(img1.ImgHeight - Form1.ClientHeight))
		Else
			form1.SetVscroll(0,0)	'Scrollbar ausblenden wenn nicht gebraucht
		EndIf
		
      Panel1.Width = img1.ImgWidth
      Panel1.Height = img1.ImgHeight
      Panel1.Invalidate 
	EndIf	
	
End Sub

Sub form1_Size(ByVal w As Integer,ByVal h As Integer,ByVal flag As Integer)
	
	' beim Maximieren/Minimieren der Form Scroll-Range neu setzen
			
		If img1.ImgWidth > w Then
			form1.SetHscroll(0,img1.ImgWidth - w)
		Else
			form1.SetHscroll(0,0)	'Scrollbar ausblenden wenn nicht gebraucht
		EndIf
		
		If img1.ImgHeight > h Then
			form1.SetVscroll(0,img1.ImgHeight - h)
		Else 
			form1.SetVscroll(0,0)	'Scrollbar ausblenden wenn nicht gebraucht
		EndIf
		panel1.Left  = 0 ' Bild zurcksetzen wenn Min. oder Maxim.
		panel1.Top   = 0
		
End Sub

Sub menu_Exit
	Form1.FormClose
End Sub

' ------------------- Create Control ---------------------------------
' Form
form1.Create("Test",10,10,400,300)
'form1.SetHscroll(0,1)						' Kann zur Laufzeit gesetzt werden
'form1.SetVscroll(0,1)						' Kann zur Laufzeit gesetzt werden
form1.onVscroll = @form1_Vscroll
form1.onHscroll = @form1_Hscroll
form1.onSize = @form1_Size

' Menu
form1.menu.Create(form1.Handle)        ' Das Menu ist in FForm enthalten
													 			
form1.menu.CreateSubMenu("Bild")       ' Das erste Popup
' Menuitem 1   
mnOpen.EventSub =@menu_Open            ' Event-Sub
form1.menu.AddItem(@mnOpen,"Open")     ' Zeiger auf das Item, Menu Text 
' Menuitem 2   
mnExit.EventSub =@menu_Exit            ' Event-Sub
mnExit.addAccel(FCONTROL,Asc("Q"),"Q") ' Accel dazu,  STRG
form1.menu.AddItem(@mnExit,"Exit")     ' Zeiger auf das Item, Menu Text 

Panel1.Create(form1.Handle,0,0,0,0)
panel1.Color = &HFFFFFF
panel1.onPaint = @panel1_Paint

' alles anzeigen
form1.Show

' Object lschen 
img1.Destructor

ExitProcess(0)
End
